<template>
  <div
    @click="
      editable
        ? (() => {
            $event.preventDefault();
            modals.show('workspaces-picker', $event);
          })()
        : null
    "
    class="flex flex-row items-center cursor-pointer select-none"
  >
    <workspaces-icon :color="iconColor" :workspace="value" />
    <div class="mx-1 text-sm whitespace-no-wrap">{{ value?.name || "Choose a workspace" }}</div>
    <div v-if="editable" class="flex flex-row items-center">
      <i class="hero selector solid text-sm"></i>
      <modal :is="modals.get('workspaces-picker')" :value="value" @input="changeWorkspace($event)" position="dynamic" />
    </div>
  </div>
</template>

<script lang="ts">
import Workspace from "@/models/Workspace";
import { useModals } from "@/use/modal";

import WorkspacesPicker from "@/components/Workspaces/Picker.vue";
import WorkspacesIcon from "@/components/Workspaces/Icon.vue";

export default {
  components: { WorkspacesIcon },
  emits: ["input"],
  props: {
    value: {
      required: false,
      type: Workspace
    },
    editable: {
      default: false,
      type: Boolean
    },
    iconColor: {
      default: "",
      type: String
    }
  },
  setup(props, context) {
    const modals = useModals({ WorkspacesPicker });
    return {
      modals,
      changeWorkspace: (workspace: Workspace) => {
        context.emit("input", workspace);
      }
    };
  }
};
</script>
